package de.vps.act.frontend.action;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.apache.log4j.Logger;

public class LoggingHashMap<K, V> extends HashMap<K, V> {

    private static final long serialVersionUID = 3877335432932820547L;
    private static Logger logger = Logger.getLogger(LoggingHashMap.class);

    public LoggingHashMap() {
        super();
        logger.debug("LoggingHashMap.LoggingHashMap() was called");
    }

    public LoggingHashMap(final int arg0) {
        super(arg0);
        logger.debug("LoggingHashMap.LoggingHashMap(int) was called, int = "
                + arg0);
    }

    public LoggingHashMap(final Map<? extends K, ? extends V> arg0) {
        super(arg0);
        logger.debug("LoggingHashMap.LoggingHashMap(Map<K,V>) was called, Map = "
                + arg0);
    }

    public LoggingHashMap(final int arg0, final float arg1) {
        super(arg0, arg1);
        logger.debug("LoggingHashMap.LoggingHashMap(int,float) was called, int = "
                + arg0 + ", float = " + arg1);
    }

    @Override
    public void clear() {
        logger.debug("LoggingHashMap.clear() was called");
        super.clear();
    }

    @Override
    public Object clone() {
        logger.debug("LoggingHashMap.clone() was called");
        return super.clone();
    }

    @Override
    public boolean containsKey(final Object key) {
        logger.debug("LoggingHashMap.containsKey(Object) was called, Object = "
                + key);
        return super.containsKey(key);
    }

    @Override
    public boolean containsValue(final Object value) {
        logger.debug("LoggingHashMap.containsValue(Object) was called, Object = "
                + value);
        return super.containsValue(value);
    }

    @Override
    public Set<java.util.Map.Entry<K, V>> entrySet() {
        logger.debug("LoggingHashMap.entrySet() was called");
        return super.entrySet();
    }

    @Override
    public V get(final Object key) {
        logger.debug("LoggingHashMap.get(Object) was called, Object = " + key);
        return super.get(key);
    }

    @Override
    public boolean isEmpty() {
        logger.debug("LoggingHashMap.isEmpty() was called");
        return super.isEmpty();
    }

    @Override
    public Set<K> keySet() {
        logger.debug("LoggingHashMap.keySet() was called");
        return super.keySet();
    }

    @Override
    public V put(final K key, final V value) {
        logger.debug("LoggingHashMap.put(K,V) was called, K = " + key
                + ", V = " + value + ", V.class = " + value.getClass());
        return super.put(key, value);
    }

    @Override
    public void putAll(final Map<? extends K, ? extends V> m) {
        logger.debug("LoggingHashMap.putAll(Map) was called, Map = " + m);
        super.putAll(m);
    }

    @Override
    public V remove(final Object key) {
        logger.debug("LoggingHashMap.remove(Object) was called, Object = "
                + key);
        return super.remove(key);
    }

    @Override
    public int size() {
        logger.debug("LoggingHashMap.size() was called");
        return super.size();
    }

    @Override
    public Collection<V> values() {
        logger.debug("LoggingHashMap.values() was called");
        return super.values();
    }

    @Override
    public boolean equals(final Object arg0) {
        logger.debug("LoggingHashMap.equals(Object) was called, Object = "
                + arg0);
        return super.equals(arg0);
    }

    @Override
    public int hashCode() {
        logger.debug("LoggingHashMap.hashCode() was called");
        return super.hashCode();
    }

    @Override
    public String toString() {
        logger.debug("LoggingHashMap.toString() was called");
        return super.toString();
    }

    // CSOFF: IllegalThrow: When overwriting transparently,
    //                      we have no other chance ...
    @Override
    protected void finalize() throws Throwable {
    // CSON: IllegalThrow
        logger.debug("LoggingHashMap.finalize() was called");
        super.finalize();
    }

}

